#include "BasicBlock.h"
#include "Constant.h"
#include "Function.h"
#include "IRBuilder.h"
#include "Module.h"
#include "Type.h"

#include <iostream>

int main()
{

    auto  mod = new Module("Cminus code"); // module name是什么无关紧要
    auto  bud = new IRBuilder(nullptr, mod);
    Type *I32Type = Type::get_int32_type(mod);
    std::vector<Type *> OneIntArg(1, I32Type);
    auto                calleeTp   = FunctionType::get(I32Type, OneIntArg);
    auto                calleeFunc = Function::create(calleeTp, "callee", mod);
    auto                bb = BasicBlock::create(mod, "entry", calleeFunc);
    bud->set_insert_point(bb);

    std::vector<Value *> arg_vs;
    for (auto arg = calleeFunc->arg_begin(); arg != calleeFunc->arg_end();
         arg++)
        arg_vs.push_back(*arg);
    auto mul = bud->create_imul(arg_vs[0], ConstantInt::get(2, mod));
    bud->create_ret(mul);

    
    auto mainTp = FunctionType::get(I32Type, {});
    auto mainFunc = Function::create(mainTp, "main", mod);
    bb = BasicBlock::create(mod, "entry", mainFunc);
    bud->set_insert_point(bb);

    auto call = bud->create_call(calleeFunc, {ConstantInt::get(110, mod)});
    bud->create_ret(call);
    

    std::cout << mod->print();
    delete mod;
    return 0;
}
